using System;
using System.Data;
using bizFacade;
using MesServerWork;

namespace MesServerFunctions
{
    partial class FunctionMES
    {
        /// <summary>
        /// 正常逻辑工作(传递机型)
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="EngineTypeID"></param>
        /// <param name="EngineType"></param>
        /// <param name="EngineID"></param>
        /// <param name="PartPallet_Code"></param>
        private void EngineTypeGetOver_PLC_Work(string OpName, int EngineTypeID, string EngineType, string EngineID, int PartPallet_Code,string OrderForm)
        {
            int IsAllowWork;
            int RepairPartStatusPLC = 0;
            int MES_QualityMask = 1;
            DataTable dt;
            dt = BaseDataSystemMES.EngineTypeChange(OpName, EngineType);
            //提示机型发生变化
            if (dt.Rows.Count > 0)
            {
                string mesValue = Newtonsoft.Json.JsonConvert.SerializeObject(dt);//<DoWhatPlc.CustomeEvetnArgs>(recData);
                string message = "MES|MaterialList_Dif_Resources|" + OpName + "|" + mesValue;
                SendMessage.AsyncSendMessage(message);
            }

            //电子看板_装配零件_临时表_增加_北汽
            //第二步，将零件信息转移到零件_临时表中
            BaseDataSystemMES.MesServer_Process_EngineTypeOverBQ(OpName);

            //通知web显示
            SendMessageFun.SendMessage("123", "111", OpName);
            MIS_BASE.Read_PalletInfo(OpName, out MES_QualityMask);//合格标志
            MIS_BASE.Read_RepairStatus_PLC(OpName, out RepairPartStatusPLC);//返修标志
            SendMessageFun.SendInfomation("QualityMask", Convert.ToString(MES_QualityMask), OpName);//显示合格标志
            SendMessageFun.SendInfomation("RepairPartStatusPLC", Convert.ToString(RepairPartStatusPLC), OpName);//显示返修标志

            // 判断是否存在细一轴 若存在则去反给PLC（11.2）35
            DataTable OneAxleDt = BaseDataSystemMES.Get_EngineOneAxle(EngineType);
            if (Convert.ToInt32(OneAxleDt.Rows[0]["result"]) == 1)
            {
                SendMessageFun.AsyncSendMessage_Notice(OpName, "该工位存在细一轴物料，请注意！");
                MIS_BASE.WritePLC(35, OpName, true);
            }

            if (MES_QualityMask == 2)
            {
                //工作完成
                //MIS_BASE.Write_MaterialVerifyOver(OpName, true);
                //SendMessageFun.SendInfomation("NgGO", "1", OpName);//显示不合格标志
                //return;
            }


            //第三步，用于工件离开后完工数量统计及工件编号追溯
            //BaseDataSystemMES.MaterialPush_EngineIDStatus_Insert(OpName);//更新订单产量

            //第四步，获取是否允许工作
            //BaseDataSystemMES.MesServer_Judge_IsCanWork(OpName, out IsAllowWork);
            ////暂时先定义为扫描完成才能进行压装工作，因为考虑到工作完成后，操作工未必会去扫描物料的情况
            //if (IsAllowWork == 1)
            //{
            //    //通知PLC允许工作,允许工作在保存完成时清空
            //    MIS_BASE.Write_FixAllow(OpName, true);
            //}
            //else
            //{
            //    SendMessageFun.AsyncSendMessage_Notice(OpName, "请扫描物料！");
            //}

        }

  
        /// <summary>
        /// 返修件需要工作
        /// </summary>
        /// <param name="OpName">工位号</param>
        private void IsNeedRepaire_OK(string OpName)
        {
            string orderForm = "";
            int engineTypeID;
            string engineType = "";
            string engineID = "";
            string palletCode = "";
            int isRepair;
            string repairCode = "";
            //从监控系统中查询出本工位信息
            BaseDataSystemMES.OpName_MIS_Moby_Select(OpName,
            out  orderForm, out  engineTypeID, out  engineType,
            out  engineID, out palletCode, out isRepair, out repairCode);

            EngineTypeGetOver_PLC_Work(OpName, engineTypeID, engineType, engineID, Convert.ToInt32(palletCode),orderForm);
        }




    }
}
